KEditToolbarWidget Class Reference

`#include <kedittoolbar.h>`

Inheritance diagram for KEditToolbarWidget:

## Signals

void | enableOk (bool)

## Public Member Functions

| KEditToolbarWidget (KActionCollection *collection, const QString &xmlfile=QString::null, bool global=true, QWidget *parent=0L)
| KEditToolbarWidget (const QString &defaultToolbar, KActionCollection *collection, const QString &file=QString::null, bool global=true, QWidget *parent=0L)
| KEditToolbarWidget (KXMLGUIFactory *factory, QWidget *parent=0L)
| KEditToolbarWidget (const QString &defaultToolbar, KXMLGUIFactory *factory, QWidget *parent=0L)
virtual | ~KEditToolbarWidget ()
virtual KActionCollection * | actionCollection () const
bool | save ()
void | rebuildKXMLGUIClients ()
Public Member Functions inherited from KXMLGUIClient
| KXMLGUIClient ()
| KXMLGUIClient (KXMLGUIClient *parent)
virtual | ~KXMLGUIClient ()
KAction * | action (const char *name) const
virtual KAction * | action (const QDomElement &element) const
virtual KInstance * | instance () const
virtual QDomDocument | domDocument () const
virtual QString | xmlFile () const
virtual QString | localXMLFile () const
void | setXMLGUIBuildDocument (const QDomDocument &doc)
QDomDocument | xmlguiBuildDocument () const
void | setFactory (KXMLGUIFactory *factory)
KXMLGUIFactory * | factory () const
KXMLGUIClient * | parentClient () const
void | insertChildClient (KXMLGUIClient *child)
void | removeChildClient (KXMLGUIClient *child)
const QPtrList< KXMLGUIClient > * | childClients ()
void | setClientBuilder (KXMLGUIBuilder *builder)
KXMLGUIBuilder * | clientBuilder () const
void | reloadXML ()
void | plugActionList (const QString &name, const QPtrList< KAction > &actionList)
void | unplugActionList (const QString &name)
void | addStateActionEnabled (const QString &state, const QString &action)
void | addStateActionDisabled (const QString &state, const QString &action)
StateChange | getActionsToChangeForState (const QString &state)
void | beginXMLPlug (QWidget *)
void | endXMLPlug ()
void | prepareXMLUnplug (QWidget *)

## Protected Slots

void | slotToolbarSelected (const QString &text)
void | slotInactiveSelected (QListViewItem *item)
void | slotActiveSelected (QListViewItem *item)
void | slotDropped (KListView *list, QDropEvent *e, QListViewItem *after)
void | slotInsertButton ()
void | slotRemoveButton ()
void | slotUpButton ()
void | slotDownButton ()
void | slotChangeIcon ()

## Protected Member Functions

void | setupLayout ()
void | insertActive (ToolbarItem *item, QListViewItem *before, bool prepend=false)
void | removeActive (ToolbarItem *item)
void | moveActive (ToolbarItem *item, QListViewItem *before)
void | initNonKPart (KActionCollection *collection, const QString &file, bool global)
void | initKPart (KXMLGUIFactory *factory)
void | loadToolbarCombo (const QString &defaultToolbar=QString::null)
void | loadActionList (QDomElement &elem)
void | updateLocal (QDomElement &elem)
virtual void | virtual_hook (int id, void *data)
Protected Member Functions inherited from KXMLGUIClient
virtual void | setInstance (KInstance *instance)
virtual void | setXMLFile (const QString &file, bool merge=false, bool setXMLDoc=true)
virtual void | setLocalXMLFile (const QString &file)
virtual void | setXML (const QString &document, bool merge=false)
virtual void | setDOMDocument (const QDomDocument &document, bool merge=false)
virtual void | conserveMemory ()
virtual void | stateChanged (const QString &newstate, ReverseStateChange reverse=StateNoReverse)

## Additional Inherited Members

Public Types inherited from KXMLGUIClient
enum | ReverseStateChange { StateNoReverse, StateReverse }
Static Public Member Functions inherited from KXMLGUIClient
static QString | findMostRecentXMLFile (const QStringList &files, QString &doc)

## Detailed Description

A widget used to customize or configure toolbars.

This is the widget that does all of the work for the KEditToolbar dialog. In most cases, you will want to use the dialog instead of this widget directly.

Typically, you would use this widget only if you wanted to embed the toolbar editing directly into your existing configure or preferences dialog.

This widget only works if your application uses the XML UI framework for creating menus and toolbars. It depends on the XML files to describe the toolbar layouts and it requires the actions to determine which buttons are active.

Author
  Kurt Granroth granr.nosp@m.oth@.nosp@m.kde.o.nosp@m.rg

Version

Id
  kedittoolbar.h 465272 2005-09-29 09:47:40Z mueller

Definition at line 270 of file kedittoolbar.h.

## Constructor & Destructor Documentation

KEditToolbarWidget::KEditToolbarWidget | ( | KActionCollection * | collection,
|  | const QString & | xmlfile = `QString::null`,
|  | bool | global = `true`,
|  | QWidget * | parent = `0L`
| ) |  |

Constructor.

This is the only entry point to this class. You `must` pass along your collection of actions (some of which appear in your toolbars). The other three parameters are optional.

The second parameter, xmlfile, is the name (absolute or relative) of your application's UI resource file. If it is left blank, then the resource file: share/apps/appname/appnameui.rc is used. This is the same resource file that is used by the default createGUI function in KMainWindow so you're usually pretty safe in leaving it blank.

The third parameter, global, controls whether or not the global resource file is used. If this is true, then you may edit all of the actions in your toolbars – global ones and local one. If it is false, then you may edit only your application's entries. The only time you should set this to false is if your application does not use the global resource file at all (very rare)

The last parameter, parent, is the standard parent stuff.

Parameters

  collection | The collection of actions to work on
  xmlfile | The application's local resource file
  global | If true, then the global resource file will also be parsed
  parent | This widget's parent

Definition at line 540 of file kedittoolbar.cpp.

KEditToolbarWidget::KEditToolbarWidget | ( | KXMLGUIFactory * | factory,
|  | QWidget * | parent = `0L`
| ) |  |

Constructor for KParts based apps.

The first parameter, factory, is a pointer to the XML GUI factory object for your application. It contains a list of all of the GUI clients (along with the action collections and xml files) and the toolbar editor uses that.

The second parameter, parent, is the standard parent

Use this like so:

KEditToolbar edit(factory());
if ( edit.exec() )
...

Parameters

  factory | Your application's factory object
  parent | This widget's parent

Definition at line 567 of file kedittoolbar.cpp.

KEditToolbarWidget::~KEditToolbarWidget | ( |  | ) |

virtual

Destructor.

Note that any changes done in this widget will `NOT` be saved in the destructor. You `must` call save() to do that.

Definition at line 592 of file kedittoolbar.cpp.

## Member Function Documentation

KActionCollection * KEditToolbarWidget::actionCollection | ( |  | ) | const

virtual

Reimplemented for internal purposes.

Reimplemented from KXMLGUIClient.

Definition at line 1056 of file kedittoolbar.cpp.

void KEditToolbarWidget::enableOk | ( | bool |  | ) |

signal

Emitted whenever any modifications are made by the user.

void KEditToolbarWidget::rebuildKXMLGUIClients | ( |  | ) |

Remove and readd all KMXLGUIClients to update the GUI.

Since
  3.5

Definition at line 709 of file kedittoolbar.cpp.

bool KEditToolbarWidget::save | ( |  | ) |

Save any changes the user made.

The file will be in the user's local directory (usually $HOME/.kde/share/apps/<appname>). The filename will be the one specified in the constructor.. or the made up one if the filename was NULL.

Returns
  The status of whether or not the save succeeded.

Definition at line 680 of file kedittoolbar.cpp.

The documentation for this class was generated from the following files:

- kedittoolbar.h
- kedittoolbar.cpp

KDE Home | KDE Accessibility Home | Description of Access Keys